// Fill out your copyright notice in the Description page of Project Settings.

#include "ViveportSDKPrivatePCH.h"
#include "ViveportUser.h"
#include "viveport_api.h"
#include <string>

FString UViveportUser::GetUserID()
{
#if PLATFORM_WINDOWS
    auto userID = std::string("");
    if (FViveportSDKModule::IsAvailable())
    {
        char buf[256];
        int length = ViveportUser()->GetUserID(buf, 256);
        userID.assign(buf, length);
    }
    FString fUserID(UTF8_TO_TCHAR(userID.c_str()));
    return fUserID;
#elif PLATFORM_ANDROID
    return FString(UTF8_TO_TCHAR(ViveportUser::GetUserID().c_str()));
#else
#endif
}

FString UViveportUser::GetUserName()
{
#if PLATFORM_WINDOWS
    auto userName = std::string("");
    if (FViveportSDKModule::IsAvailable())
    {
        char buf[256];
        int length = ViveportUser()->GetUserName(buf, 256);
        userName.assign(buf, length);
    }
    FString fUserName(UTF8_TO_TCHAR(userName.c_str()));
    return fUserName;
#elif PLATFORM_ANDROID
    return FString(UTF8_TO_TCHAR(ViveportUser::GetUserName().c_str()));
#endif
}

FString UViveportUser::GetUserAvatarUrl()
{
#if PLATFORM_WINDOWS
    auto avatar = std::string("");
    if (FViveportSDKModule::IsAvailable())
    {
        char buf[256];
        int length = ViveportUser()->GetUserAvatarUrl(buf, 256);
        avatar.assign(buf, length);
    }
    FString fAvatar(UTF8_TO_TCHAR(avatar.c_str()));
    return fAvatar;
#elif PLATFORM_ANDROID
    return FString(UTF8_TO_TCHAR(ViveportUser::GetUserAvatar().c_str()));
#endif
}

